Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Canon.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Canon.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Canon.pm	(revision 34921)
@@ -286,43 +415,180 @@
     202 => 'Canon EF 28-80mm f/3.5-5.6 USM IV',
     208 => 'Canon EF 22-55mm f/4-5.6 USM', #32
-    209 => 'Canon EF 55-200mm f/4.5-5.6', #32
+    209 => 'Canon EF 55-200mm f/4.5-5.6', #32 (USM mk I version? ref IB)
     210 => 'Canon EF 28-90mm f/4-5.6 USM', #32
     211 => 'Canon EF 28-200mm f/3.5-5.6 USM', #15
     212 => 'Canon EF 28-105mm f/4-5.6 USM', #15
-    213 => 'Canon EF 90-300mm f/4.5-5.6 USM',
+    213 => 'Canon EF 90-300mm f/4.5-5.6 USM or Tamron Lens',
+    213.1 => 'Tamron SP 150-600mm f/5-6.3 Di VC USD (A011)', #forum5565
+    213.2 => 'Tamron 16-300mm f/3.5-6.3 Di II VC PZD Macro (B016)', #PH
+    213.3 => 'Tamron SP 35mm f/1.8 Di VC USD (F012)', #PH
+    213.4 => 'Tamron SP 45mm f/1.8 Di VC USD (F013)', #PH
     214 => 'Canon EF-S 18-55mm f/3.5-5.6 USM', #PH/34
     215 => 'Canon EF 55-200mm f/4.5-5.6 II USM',
-    224 => 'Canon EF 70-200mm f/2.8L IS', #11
-    225 => 'Canon EF 70-200mm f/2.8L IS + 1.4x', #11
-    226 => 'Canon EF 70-200mm f/2.8L IS + 2x', #14
-    227 => 'Canon EF 70-200mm f/2.8L IS + 2.8x', #32
+    217 => 'Tamron AF 18-270mm f/3.5-6.3 Di II VC PZD', #47
+    220 => 'Yongnuo YN 50mm f/1.8', #IB
+    224 => 'Canon EF 70-200mm f/2.8L IS USM', #11
+    225 => 'Canon EF 70-200mm f/2.8L IS USM + 1.4x', #11
+    226 => 'Canon EF 70-200mm f/2.8L IS USM + 2x', #14
+    227 => 'Canon EF 70-200mm f/2.8L IS USM + 2.8x', #32
     228 => 'Canon EF 28-105mm f/3.5-4.5 USM', #32
-    229 => 'Canon EF 16-35mm f/2.8L', #PH
-    230 => 'Canon EF 24-70mm f/2.8L', #9
-    231 => 'Canon EF 17-40mm f/4L',
+    229 => 'Canon EF 16-35mm f/2.8L USM', #PH
+    230 => 'Canon EF 24-70mm f/2.8L USM', #9
+    231 => 'Canon EF 17-40mm f/4L USM or Sigma Lens',
+    231.1 => 'Sigma 12-24mm f/4 DG HSM A016', #IB
     232 => 'Canon EF 70-300mm f/4.5-5.6 DO IS USM', #15
-    233 => 'Canon EF 28-300mm f/3.5-5.6L IS', #PH
-    234 => 'Canon EF-S 17-85mm f4-5.6 IS USM', #19
+    233 => 'Canon EF 28-300mm f/3.5-5.6L IS USM', #PH
+    234 => 'Canon EF-S 17-85mm f/4-5.6 IS USM or Tokina Lens', #19
+    234.1 => 'Tokina AT-X 12-28 PRO DX 12-28mm f/4', #50/NJ
     235 => 'Canon EF-S 10-22mm f/3.5-4.5 USM', #15
     236 => 'Canon EF-S 60mm f/2.8 Macro USM', #15
-    237 => 'Canon EF 24-105mm f/4L IS', #15
-    238 => 'Canon EF 70-300mm f/4-5.6 IS USM', #15
-    239 => 'Canon EF 85mm f/1.2L II', #15
-    240 => 'Canon EF-S 17-55mm f/2.8 IS USM', #15
-    241 => 'Canon EF 50mm f/1.2L', #15
-    242 => 'Canon EF 70-200mm f/4L IS', #PH
-    243 => 'Canon EF 70-200mm f/4L IS + 1.4x', #15
-    244 => 'Canon EF 70-200mm f/4L IS + 2x', #PH
-    245 => 'Canon EF 70-200mm f/4L IS + 2.8x', #32
-    246 => 'Canon EF 16-35mm f/2.8L II', #PH
+    237 => 'Canon EF 24-105mm f/4L IS USM', #15
+    238 => 'Canon EF 70-300mm f/4-5.6 IS USM', #15 (and version II? ref 42)
+    239 => 'Canon EF 85mm f/1.2L II USM or Rokinon Lens', #15
+    239.1 => 'Rokinon SP 85mm f/1.2', #IB
+    240 => 'Canon EF-S 17-55mm f/2.8 IS USM or Sigma Lens', #15
+    240.1 => 'Sigma 17-50mm f/2.8 EX DC OS HSM', #https://github.com/Exiv2/exiv2/issues/397
+    241 => 'Canon EF 50mm f/1.2L USM', #15
+    242 => 'Canon EF 70-200mm f/4L IS USM', #PH
+    243 => 'Canon EF 70-200mm f/4L IS USM + 1.4x', #15
+    244 => 'Canon EF 70-200mm f/4L IS USM + 2x', #PH
+    245 => 'Canon EF 70-200mm f/4L IS USM + 2.8x', #32
+    246 => 'Canon EF 16-35mm f/2.8L II USM', #PH
     247 => 'Canon EF 14mm f/2.8L II USM', #32
-    248 => 'Canon EF 200mm f/2L IS', #42
-    249 => 'Canon EF 800mm f/5.6L IS', #35
-    250 => 'Canon EF 24 f/1.4L II', #41
+    248 => 'Canon EF 200mm f/2L IS USM or Sigma Lens', #42
+    248.1 => 'Sigma 24-35mm f/2 DG HSM | A', #JR
+    248.2 => 'Sigma 135mm f/2 FF High-Speed Prime | 017', #IB
+    248.3 => 'Sigma 24-35mm f/2.2 FF Zoom | 017', #IB
+    248.4 => 'Sigma 135mm f/1.8 DG HSM A017', #IB
+    249 => 'Canon EF 800mm f/5.6L IS USM', #35
+    250 => 'Canon EF 24mm f/1.4L II USM or Sigma Lens', #41
+    250.1 => 'Sigma 20mm f/1.4 DG HSM | A', #IB
+    250.2 => 'Sigma 20mm f/1.5 FF High-Speed Prime | 017', #IB
+    250.3 => 'Tokina Opera 16-28mm f/2.8 FF', #IB
+    250.4 => 'Sigma 85mm f/1.4 DG HSM A016', #IB
     251 => 'Canon EF 70-200mm f/2.8L IS II USM',
+    251.1 => 'Canon EF 70-200mm f/2.8L IS III USM', #IB
+    252 => 'Canon EF 70-200mm f/2.8L IS II USM + 1.4x', #50 (1.4x Mk II)
+    252.1 => 'Canon EF 70-200mm f/2.8L IS III USM + 1.4x', #PH (NC)
+    253 => 'Canon EF 70-200mm f/2.8L IS II USM + 2x', #PH (NC)
+    253.1 => 'Canon EF 70-200mm f/2.8L IS III USM + 2x', #PH (NC)
+    # 253.2 => 'Tamron SP 70-200mm f/2.8 Di VC USD G2 (A025) + 2x', #forum9367
     254 => 'Canon EF 100mm f/2.8L Macro IS USM', #42
+    255 => 'Sigma 24-105mm f/4 DG OS HSM | A or Other Lens', #50
+    255.1 => 'Sigma 180mm f/2.8 EX DG OS HSM APO Macro', #50
+    255.2 => 'Tamron SP 70-200mm f/2.8 Di VC USD', #exiv issue 1202 (A009)
+    368 => 'Sigma 14-24mm f/2.8 DG HSM | A or other Sigma Lens', #IB (A018)
+    368.1 => 'Sigma 20mm f/1.4 DG HSM | A', #50 (newer firmware)
+    368.2 => 'Sigma 50mm f/1.4 DG HSM | A', #50
+    368.3 => 'Sigma 40mm f/1.4 DG HSM | A', #IB (018)
+    368.4 => 'Sigma 60-600mm f/4.5-6.3 DG OS HSM | S', #IB (018)
+    368.5 => 'Sigma 28mm f/1.4 DG HSM | A', #IB (A019)
+    368.6 => 'Sigma 150-600mm f/5-6.3 DG OS HSM | S', #50
+    368.7 => 'Sigma 85mm f/1.4 DG HSM | A', #IB (016)
+    368.8 => 'Sigma 105mm f/1.4 DG HSM', #IB (A018)
+    368.9 => 'Sigma 14-24mm f/2.8 DG HSM', #IB (A018)
+   '368.10' => 'Sigma 35mm f/1.4 DG HSM | A', #PH (012)
+   '368.11' => 'Sigma 70mm f/2.8 DG Macro', #IB (A018)
+   '368.12' => 'Sigma 18-35mm f/1.8 DC HSM | A', #50
     # Note: LensType 488 (0x1e8) is reported as 232 (0xe8) in 7D CameraSettings
     488 => 'Canon EF-S 15-85mm f/3.5-5.6 IS USM', #PH
     489 => 'Canon EF 70-300mm f/4-5.6L IS USM', #Gerald Kapounek
+    490 => 'Canon EF 8-15mm f/4L Fisheye USM', #Klaus Reinfeld (PH added "Fisheye")
+    491 => 'Canon EF 300mm f/2.8L IS II USM or Tamron Lens', #42
+    491.1 => 'Tamron SP 70-200mm f/2.8 Di VC USD G2 (A025)', #IB
+    491.2 => 'Tamron 18-400mm f/3.5-6.3 Di II VC HLD (B028)', #IB
+    491.3 => 'Tamron 100-400mm f/4.5-6.3 Di VC USD (A035)', #IB
+    491.4 => 'Tamron 70-210mm f/4 Di VC USD (A034)', #IB
+    491.5 => 'Tamron 70-210mm f/4 Di VC USD (A034) + 1.4x', #IB
+    491.6 => 'Tamron SP 24-70mm f/2.8 Di VC USD G2 (A032)',
+    492 => 'Canon EF 400mm f/2.8L IS II USM', #PH
+    493 => 'Canon EF 500mm f/4L IS II USM or EF 24-105mm f4L IS USM', #PH
+    493.1 => 'Canon EF 24-105mm f/4L IS USM', #PH (should recheck this)
+    494 => 'Canon EF 600mm f/4L IS II USM', #PH
+    495 => 'Canon EF 24-70mm f/2.8L II USM or Sigma Lens', #PH
+    495.1 => 'Sigma 24-70mm f/2.8 DG OS HSM | A', #IB (017)
+    496 => 'Canon EF 200-400mm f/4L IS USM', #PH
+    499 => 'Canon EF 200-400mm f/4L IS USM + 1.4x', #50
+    502 => 'Canon EF 28mm f/2.8 IS USM or Tamron Lens', #PH
+    502.1 => 'Tamron 35mm f/1.8 Di VC USD (F012)', #forum9757
+    503 => 'Canon EF 24mm f/2.8 IS USM', #PH
+    504 => 'Canon EF 24-70mm f/4L IS USM', #PH
+    505 => 'Canon EF 35mm f/2 IS USM', #PH
+    506 => 'Canon EF 400mm f/4 DO IS II USM', #42
+    507 => 'Canon EF 16-35mm f/4L IS USM', #42
+    508 => 'Canon EF 11-24mm f/4L USM or Tamron Lens', #PH
+    508.1 => 'Tamron 10-24mm f/3.5-4.5 Di II VC HLD (B023)', #PH
+    624 => 'Sigma 70-200mm f/2.8 DG OS HSM | S', #IB (018)
+    747 => 'Canon EF 100-400mm f/4.5-5.6L IS II USM or Tamron Lens', #JR
+    747.1 => 'Tamron SP 150-600mm f/5-6.3 Di VC USD G2', #50
+    748 => 'Canon EF 100-400mm f/4.5-5.6L IS II USM + 1.4x or Tamron Lens', #JR (1.4x Mk III)
+    748.1 => 'Tamron 100-400mm f/4.5-6.3 Di VC USD A035E + 1.4x', #IB
+    748.2 => 'Tamron 70-210mm f/4 Di VC USD (A034) + 2x', #IB
+    749 => 'Tamron 100-400mm f/4.5-6.3 Di VC USD A035E + 2x', #IB
+    750 => 'Canon EF 35mm f/1.4L II USM or Tamron Lens', #42
+    750.1 => 'Tamron SP 85mm f/1.8 Di VC USD (F016)', #Exiv2#1072
+    750.2 => 'Tamron SP 45mm f/1.8 Di VC USD (F013)', #PH
+    751 => 'Canon EF 16-35mm f/2.8L III USM', #42
+    752 => 'Canon EF 24-105mm f/4L IS II USM', #42
+    753 => 'Canon EF 85mm f/1.4L IS USM', #42
+    754 => 'Canon EF 70-200mm f/4L IS II USM', #IB
+    757 => 'Canon EF 400mm f/2.8L IS III USM', #IB
+    758 => 'Canon EF 600mm f/4L IS III USM', #IB
+
+    1136 => 'Sigma 24-70mm f/2.8 DG OS HSM | A', #IB (017)
+    # (STM lenses - 0x10xx)
+    4142 => 'Canon EF-S 18-135mm f/3.5-5.6 IS STM',
+    4143 => 'Canon EF-M 18-55mm f/3.5-5.6 IS STM or Tamron Lens',
+    4143.1 => 'Tamron 18-200mm f/3.5-6.3 Di III VC', #42
+    4144 => 'Canon EF 40mm f/2.8 STM', #50
+    4145 => 'Canon EF-M 22mm f/2 STM', #34
+    4146 => 'Canon EF-S 18-55mm f/3.5-5.6 IS STM', #PH
+    4147 => 'Canon EF-M 11-22mm f/4-5.6 IS STM', #42
+    4148 => 'Canon EF-S 55-250mm f/4-5.6 IS STM', #42
+    4149 => 'Canon EF-M 55-200mm f/4.5-6.3 IS STM', #42
+    4150 => 'Canon EF-S 10-18mm f/4.5-5.6 IS STM', #42
+    4152 => 'Canon EF 24-105mm f/3.5-5.6 IS STM', #42
+    4153 => 'Canon EF-M 15-45mm f/3.5-6.3 IS STM', #PH
+    4154 => 'Canon EF-S 24mm f/2.8 STM', #IB
+    4155 => 'Canon EF-M 28mm f/3.5 Macro IS STM', #42
+    4156 => 'Canon EF 50mm f/1.8 STM', #42
+    4157 => 'Canon EF-M 18-150mm f/3.5-6.3 IS STM', #42
+    4158 => 'Canon EF-S 18-55mm f/4-5.6 IS STM', #PH
+    4159 => 'Canon EF-M 32mm f/1.4 STM', #42
+    4160 => 'Canon EF-S 35mm f/2.8 Macro IS STM', #42
+    4208 => 'Sigma 56mm f/1.4 DC DN | C', #forum10603
+    # (Nano USM lenses - 0x90xx)
+    36910 => 'Canon EF 70-300mm f/4-5.6 IS II USM', #42
+    36912 => 'Canon EF-S 18-135mm f/3.5-5.6 IS USM', #42
+    # (CN-E lenses - 0xf0xx)
+    61491 => 'Canon CN-E 14mm T3.1 L F', #PH
+    61492 => 'Canon CN-E 24mm T1.5 L F', #PH
+  # 61493 - missing CN-E 50mm T1.3 L F ?
+    61494 => 'Canon CN-E 85mm T1.3 L F', #PH
+    61495 => 'Canon CN-E 135mm T2.2 L F', #PH
+    61496 => 'Canon CN-E 35mm T1.5 L F', #PH
+    # see RFLensType tag for master list of 61182 RF lenses
+    61182 => 'Canon RF 50mm F1.2L USM or other Canon RF Lens',
+    61182.1 => 'Canon RF 24-105mm F4L IS USM',
+    61182.2 => 'Canon RF 28-70mm F2L USM',
+    61182.3 => 'Canon RF 35mm F1.8 MACRO IS STM',
+    61182.4 => 'Canon RF 85mm F1.2L USM',
+    61182.5 => 'Canon RF 85mm F1.2L USM DS',
+    61182.6 => 'Canon RF 24-70mm F2.8L IS USM',
+    61182.7 => 'Canon RF 15-35mm F2.8L IS USM',
+    61182.8 => 'Canon RF 24-240mm F4-6.3 IS USM',
+    61182.9 => 'Canon RF 70-200mm F2.8L IS USM',
+    61182.10 => 'Canon RF 85mm F2 MACRO IS STM',
+    61182.11 => 'Canon RF 600mm F11 IS STM',
+    61182.12 => 'Canon RF 600mm F11 IS STM + RF1.4x',
+    61182.13 => 'Canon RF 600mm F11 IS STM + RF2x',
+    61182.14 => 'Canon RF 800mm F11 IS STM',
+    61182.15 => 'Canon RF 800mm F11 IS STM + RF1.4x',
+    61182.16 => 'Canon RF 800mm F11 IS STM + RF2x',
+    61182.17 => 'Canon RF 24-105mm F4-7.1 IS STM',
+    61182.18 => 'Canon RF 100-500mm F4.5-7.1L IS USM',
+    61182.19 => 'Canon RF 100-500mm F4.5-7.1L IS USM + RF1.4x',
+    61182.20 => 'Canon RF 100-500mm F4.5-7.1L IS USM + RF2x',
+    65535 => 'n/a',
 );
 
@@ -450,5 +716,5 @@
     0x2800000 => 'PowerShot A495',
     0x2810000 => 'PowerShot A490',
-    0x2820000 => 'PowerShot A3100 IS',
+    0x2820000 => 'PowerShot A3100/A3150 IS', # (different cameras, same ID)
     0x2830000 => 'PowerShot A3000 IS',
     0x2840000 => 'PowerShot SD1400 IS / IXUS 130 / IXY 400F',
@@ -464,5 +730,5 @@
     0x2980000 => 'PowerShot A3300 IS',
     0x2990000 => 'PowerShot A3200 IS',
-    0x3000000 => 'PowerShot ELPH 500 HS / IXUS 310 HS / IXY 31 S',
+    0x3000000 => 'PowerShot ELPH 500 HS / IXUS 310 HS / IXY 31S',
     0x3010000 => 'PowerShot Pro90 IS',
     0x3010001 => 'PowerShot A800',
@@ -473,6 +739,107 @@
     0x3060000 => 'PowerShot A1200',
     0x3070000 => 'PowerShot SX220 HS',
+    0x3080000 => 'PowerShot G1 X',
+    0x3090000 => 'PowerShot SX150 IS',
+    0x3100000 => 'PowerShot ELPH 510 HS / IXUS 1100 HS / IXY 51S',
+    0x3110000 => 'PowerShot S100 (new)',
+    0x3130000 => 'PowerShot SX40 HS',
+    0x3120000 => 'PowerShot ELPH 310 HS / IXUS 230 HS / IXY 600F',
+    # the Canon page lists the IXY 32S as "Japan only", but many other
+    # sites list the ELPH 500 HS and IXUS 320 HS as being the same model.
+    # I haven't been able to find an IXUS 320 sample, and the ELPH 500 HS
+    # is already associated with other IXUS and IXY models - PH
+    0x3140000 => 'IXY 32S', # (PowerShot ELPH 500 HS / IXUS 320 HS ??)
+    0x3160000 => 'PowerShot A1300',
+    0x3170000 => 'PowerShot A810',
+    0x3180000 => 'PowerShot ELPH 320 HS / IXUS 240 HS / IXY 420F',
+    0x3190000 => 'PowerShot ELPH 110 HS / IXUS 125 HS / IXY 220F',
+    0x3200000 => 'PowerShot D20',
+    0x3210000 => 'PowerShot A4000 IS',
+    0x3220000 => 'PowerShot SX260 HS',
+    0x3230000 => 'PowerShot SX240 HS',
+    0x3240000 => 'PowerShot ELPH 530 HS / IXUS 510 HS / IXY 1',
+    0x3250000 => 'PowerShot ELPH 520 HS / IXUS 500 HS / IXY 3',
+    0x3260000 => 'PowerShot A3400 IS',
+    0x3270000 => 'PowerShot A2400 IS',
+    0x3280000 => 'PowerShot A2300',
+    0x3320000 => 'PowerShot S100V', #IB
+    0x3330000 => 'PowerShot G15', #25
+    0x3340000 => 'PowerShot SX50 HS', #25/forum8196
+    0x3350000 => 'PowerShot SX160 IS',
+    0x3360000 => 'PowerShot S110 (new)',
+    0x3370000 => 'PowerShot SX500 IS',
+    0x3380000 => 'PowerShot N',
+    0x3390000 => 'IXUS 245 HS / IXY 430F', # (no PowerShot)
+    0x3400000 => 'PowerShot SX280 HS',
+    0x3410000 => 'PowerShot SX270 HS',
+    0x3420000 => 'PowerShot A3500 IS',
+    0x3430000 => 'PowerShot A2600',
+    0x3440000 => 'PowerShot SX275 HS', #forum8199
+    0x3450000 => 'PowerShot A1400',
+    0x3460000 => 'PowerShot ELPH 130 IS / IXUS 140 / IXY 110F',
+    0x3470000 => 'PowerShot ELPH 115/120 IS / IXUS 132/135 / IXY 90F/100F',
+    0x3490000 => 'PowerShot ELPH 330 HS / IXUS 255 HS / IXY 610F',
+    0x3510000 => 'PowerShot A2500',
+    0x3540000 => 'PowerShot G16',
+    0x3550000 => 'PowerShot S120',
+    0x3560000 => 'PowerShot SX170 IS',
+    0x3580000 => 'PowerShot SX510 HS',
+    0x3590000 => 'PowerShot S200 (new)',
+    0x3600000 => 'IXY 620F', # (no PowerShot or IXUS?)
+    0x3610000 => 'PowerShot N100',
+    0x3640000 => 'PowerShot G1 X Mark II',
+    0x3650000 => 'PowerShot D30',
+    0x3660000 => 'PowerShot SX700 HS',
+    0x3670000 => 'PowerShot SX600 HS',
+    0x3680000 => 'PowerShot ELPH 140 IS / IXUS 150 / IXY 130',
+    0x3690000 => 'PowerShot ELPH 135 / IXUS 145 / IXY 120',
+    0x3700000 => 'PowerShot ELPH 340 HS / IXUS 265 HS / IXY 630',
+    0x3710000 => 'PowerShot ELPH 150 IS / IXUS 155 / IXY 140',
+    0x3740000 => 'EOS M3', #IB
+    0x3750000 => 'PowerShot SX60 HS', #IB/NJ
+    0x3760000 => 'PowerShot SX520 HS', #IB
+    0x3770000 => 'PowerShot SX400 IS',
+    0x3780000 => 'PowerShot G7 X', #IB
+    0x3790000 => 'PowerShot N2',
+    0x3800000 => 'PowerShot SX530 HS',
+    0x3820000 => 'PowerShot SX710 HS',
+    0x3830000 => 'PowerShot SX610 HS',
+    0x3840000 => 'EOS M10',
+    0x3850000 => 'PowerShot G3 X',
+    0x3860000 => 'PowerShot ELPH 165 HS / IXUS 165 / IXY 160',
+    0x3870000 => 'PowerShot ELPH 160 / IXUS 160',
+    0x3880000 => 'PowerShot ELPH 350 HS / IXUS 275 HS / IXY 640',
+    0x3890000 => 'PowerShot ELPH 170 IS / IXUS 170',
+    0x3910000 => 'PowerShot SX410 IS',
+    0x3930000 => 'PowerShot G9 X',
+    0x3940000 => 'EOS M5', #IB
+    0x3950000 => 'PowerShot G5 X',
+    0x3970000 => 'PowerShot G7 X Mark II',
+    0x3980000 => 'EOS M100', #42
+    0x3990000 => 'PowerShot ELPH 360 HS / IXUS 285 HS / IXY 650',
+    0x4010000 => 'PowerShot SX540 HS',
+    0x4020000 => 'PowerShot SX420 IS',
+    0x4030000 => 'PowerShot ELPH 190 IS / IXUS 180 / IXY 190',
     0x4040000 => 'PowerShot G1',
+    0x4040001 => 'PowerShot ELPH 180 IS / IXUS 175 / IXY 180', #forum10402
+    0x4050000 => 'PowerShot SX720 HS',
+    0x4060000 => 'PowerShot SX620 HS',
+    0x4070000 => 'EOS M6',
+    0x4100000 => 'PowerShot G9 X Mark II',
+    0x412     => 'EOS M50 / Kiss M', # (yes, no "0000")
+    0x4150000 => 'PowerShot ELPH 185 / IXUS 185 / IXY 200',
+    0x4160000 => 'PowerShot SX430 IS',
+    0x4170000 => 'PowerShot SX730 HS',
+    0x4180000 => 'PowerShot G1 X Mark III', #IB
     0x6040000 => 'PowerShot S100 / Digital IXUS / IXY Digital',
+    0x801     => 'PowerShot SX740 HS',
+    0x804     => 'PowerShot G5 X Mark II',
+    0x805     => 'PowerShot SX70 HS',
+    0x808     => 'PowerShot G7 X Mark III',
+    0x811     => 'EOS M6 Mark II', #IB
+    0x812     => 'EOS M200', #25
+
+# (see http://cweb.canon.jp/e-support/faq/answer/digitalcamera/10447-1.html for PowerShot/IXUS/IXY names)
+
     0x4007d673 => 'DC19/DC21/DC22',
     0x4007d674 => 'XH A1',
@@ -487,4 +854,5 @@
     0x4007d81c => 'HF11',
     0x4007d878 => 'HV30',
+    0x4007d87c => 'XH A1S',
     0x4007d87e => 'DC301/DC310/DC311/DC320/DC330',
     0x4007d87f => 'FS100',
@@ -494,12 +862,17 @@
     0x4007d926 => 'HF S11', # (LEGRIA)
     0x4007d978 => 'HV40', # (LEGRIA)
-    0x4007d987 => 'DC410/DC420',
+    0x4007d987 => 'DC410/DC411/DC420',
     0x4007d988 => 'FS19/FS20/FS21/FS22/FS200', # (LEGRIA)
     0x4007d989 => 'HF20/HF200', # (LEGRIA)
     0x4007d98a => 'HF S10/S100', # (LEGRIA/VIXIA)
-    0x4007da8e => 'HF R16/R17/R18/R100/R106', # (LEGRIA/VIXIA)
-    0x4007da8f => 'HF M31/M36/M300', # (LEGRIA/VIXIA, probably also HF M30)
+    0x4007da8e => 'HF R10/R16/R17/R18/R100/R106', # (LEGRIA/VIXIA)
+    0x4007da8f => 'HF M30/M31/M36/M300/M306', # (LEGRIA/VIXIA)
     0x4007da90 => 'HF S20/S21/S200', # (LEGRIA/VIXIA)
-    0x4007da92 => 'FS36/FS37/FS305/FS306/FS307',
+    0x4007da92 => 'FS31/FS36/FS37/FS300/FS305/FS306/FS307',
+    0x4007dca0 => 'EOS C300',
+    0x4007dda9 => 'HF G25', # (LEGRIA)
+    0x4007dfb4 => 'XC10',
+    0x4007e1c3 => 'EOS C200',
+
     # NOTE: some pre-production models may have a model name of
     # "Canon EOS Kxxx", where "xxx" is the last 3 digits of the model ID below.
@@ -519,19 +892,64 @@
     0x80000215 => 'EOS-1Ds Mark III',
     0x80000218 => 'EOS 5D Mark II',
+    0x80000219 => 'WFT-E1',
     0x80000232 => 'EOS-1D Mark II N',
     0x80000234 => 'EOS 30D',
-    0x80000236 => 'EOS Digital Rebel XTi / 400D / Kiss Digital X', # and K236
+    0x80000236 => 'EOS Digital Rebel XTi / 400D / Kiss Digital X',
+    0x80000241 => 'WFT-E2',
+    0x80000246 => 'WFT-E3',
     0x80000250 => 'EOS 7D',
     0x80000252 => 'EOS Rebel T1i / 500D / Kiss X3',
     0x80000254 => 'EOS Rebel XS / 1000D / Kiss F',
     0x80000261 => 'EOS 50D',
+    0x80000269 => 'EOS-1D X',
     0x80000270 => 'EOS Rebel T2i / 550D / Kiss X4',
+    0x80000271 => 'WFT-E4',
+    0x80000273 => 'WFT-E5',
     0x80000281 => 'EOS-1D Mark IV',
+    0x80000285 => 'EOS 5D Mark III',
     0x80000286 => 'EOS Rebel T3i / 600D / Kiss X5',
     0x80000287 => 'EOS 60D',
     0x80000288 => 'EOS Rebel T3 / 1100D / Kiss X50',
+    0x80000289 => 'EOS 7D Mark II', #IB
+    0x80000297 => 'WFT-E2 II',
+    0x80000298 => 'WFT-E4 II',
+    0x80000301 => 'EOS Rebel T4i / 650D / Kiss X6i',
+    0x80000302 => 'EOS 6D', #25
+    0x80000324 => 'EOS-1D C', #(NC)
+    0x80000325 => 'EOS 70D',
+    0x80000326 => 'EOS Rebel T5i / 700D / Kiss X7i',
+    0x80000327 => 'EOS Rebel T5 / 1200D / Kiss X70 / Hi',
+    0x80000328 => 'EOS-1D X Mark II', #42
+    0x80000331 => 'EOS M',
+    0x80000350 => 'EOS 80D', #42
+    0x80000355 => 'EOS M2',
+    0x80000346 => 'EOS Rebel SL1 / 100D / Kiss X7',
+    0x80000347 => 'EOS Rebel T6s / 760D / 8000D',
+    0x80000349 => 'EOS 5D Mark IV', #42
+    0x80000382 => 'EOS 5DS',
+    0x80000393 => 'EOS Rebel T6i / 750D / Kiss X8i',
+    0x80000401 => 'EOS 5DS R',
+    0x80000404 => 'EOS Rebel T6 / 1300D / Kiss X80',
+    0x80000405 => 'EOS Rebel T7i / 800D / Kiss X9i',
+    0x80000406 => 'EOS 6D Mark II', #IB/42
+    0x80000408 => 'EOS 77D / 9000D',
+    0x80000417 => 'EOS Rebel SL2 / 200D / Kiss X9', #IB/42
+    0x80000421 => 'EOS R5', #PH
+    0x80000422 => 'EOS Rebel T100 / 4000D / 3000D', #IB (3000D in China; Kiss? - PH)
+    0x80000424 => 'EOS R', #IB
+    0x80000428 => 'EOS-1D X Mark III', #IB
+    0x80000432 => 'EOS Rebel T7 / 2000D / 1500D / Kiss X90', #IB
+    0x80000433 => 'EOS RP',
+    0x80000435 => 'EOS Rebel T8i / 850D / X10i', #JR/PH
+    0x80000436 => 'EOS SL3 / 250D / Kiss X10', #25
+    0x80000437 => 'EOS 90D', #IB
+    0x80000453 => 'EOS R6', #PH
+    0x80000467 => 'PowerShot ZOOM',
+    0x80000520 => 'EOS D2000C', #IB
+    0x80000560 => 'EOS D6000C', #PH (guess)
 );
 
 my %canonQuality = (
+    -1 => 'n/a', # (PH, EOS M MOV video)
     1 => 'Economy',
     2 => 'Normal',
@@ -539,7 +957,10 @@
     4 => 'RAW',
     5 => 'Superfine',
+    7 => 'CRAW', #42
     130 => 'Normal Movie', #22
+    131 => 'Movie (2)', #PH (7DmkII 1920x1080)
 );
 my %canonImageSize = (
+   -1 => 'n/a',
     0 => 'Large',
     1 => 'Medium',
@@ -559,4 +980,5 @@
     137 => '1280x720 Movie', #PH (S95 24fps; D60 50fps)
     142 => '1920x1080 Movie', #PH (D60 25fps)
+    143 => '4096x2160 Movie', #PH (C200)
 );
 my %canonWhiteBalance = (
@@ -584,5 +1006,5 @@
     21 => 'PC Set5', #PH
     # 22 - Custom 2?
-    # 23 - Custom 3?
+    23 => 'Auto (ambience priority)', #PH (5DS)
     # 30 - Click White Balance?
     # 31 - Shot Settings?
@@ -622,4 +1044,7 @@
     0x86 => 'Monochrome',
     0x87 => 'Auto', #PH
+    0x88 => 'Fine Detail', #PH
+    0xff => 'n/a', #PH (guess)
+    0xffff => 'n/a', #PH (guess)
 );
 my %userDefStyles = ( #12/48
@@ -638,4 +1063,5 @@
     0x85 => 'Faithful',
     0x86 => 'Monochrome',
+    0x87 => 'Auto', #PH
 );
 
@@ -643,5 +1069,5 @@
 my %psConv = (
     -559038737 => 'n/a', # = 0xdeadbeef ! LOL
-    OTHER => sub { return shift },
+    OTHER => sub { shift },
 );
 my %psInfo = (
@@ -690,4 +1116,6 @@
     WRITABLE => 1,
 );
+
+my %offOn = ( 0 => 'Off', 1 => 'On' );
 
 #------------------------------------------------------------------------------
@@ -706,7 +1134,5 @@
     0x2 => {
         Name => 'CanonFocalLength',
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::FocalLength',
-        },
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::FocalLength' },
     },
     0x3 => {
@@ -723,7 +1149,5 @@
     0x5 => {
         Name => 'CanonPanorama',
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::Panorama',
-        },
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::Panorama' },
     },
     0x6 => {
@@ -788,105 +1212,135 @@
             # (save size of this record as "CameraInfoCount" for later tests)
             Condition => '($$self{CameraInfoCount} = $count) and $$self{Model} =~ /\b1DS?$/',
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::CameraInfo1D',
-            },
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo1D' },
         },
         {
             Name => 'CanonCameraInfo1DmkII',
             Condition => '$$self{Model} =~ /\b1Ds? Mark II$/',
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::CameraInfo1DmkII',
-            },
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo1DmkII' },
         },
         {
             Name => 'CanonCameraInfo1DmkIIN',
             Condition => '$$self{Model} =~ /\b1Ds? Mark II N$/',
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::CameraInfo1DmkIIN',
-            },
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo1DmkIIN' },
         },
         {
             Name => 'CanonCameraInfo1DmkIII',
             Condition => '$$self{Model} =~ /\b1Ds? Mark III$/',
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::CameraInfo1DmkIII',
-            },
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo1DmkIII' },
         },
         {
             Name => 'CanonCameraInfo1DmkIV',
             Condition => '$$self{Model} =~ /\b1D Mark IV$/',
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::CameraInfo1DmkIV',
-            },
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo1DmkIV' },
+        },
+        {
+            Name => 'CanonCameraInfo1DX',
+            Condition => '$$self{Model} =~ /EOS-1D X$/',
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo1DX' },
         },
         {
             Name => 'CanonCameraInfo5D',
             Condition => '$$self{Model} =~ /EOS 5D$/',
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::CameraInfo5D',
-            },
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo5D' },
         },
         {
             Name => 'CanonCameraInfo5DmkII',
             Condition => '$$self{Model} =~ /EOS 5D Mark II$/',
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::CameraInfo5DmkII',
-            },
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo5DmkII' },
+        },
+        {
+            Name => 'CanonCameraInfo5DmkIII',
+            Condition => '$$self{Model} =~ /EOS 5D Mark III$/',
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo5DmkIII' },
+        },
+        {
+            Name => 'CanonCameraInfo6D',
+            Condition => '$$self{Model} =~ /EOS 6D$/',
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo6D' },
         },
         {
             Name => 'CanonCameraInfo7D',
             Condition => '$$self{Model} =~ /EOS 7D$/',
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::CameraInfo7D',
-            },
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo7D' },
         },
         {
             Name => 'CanonCameraInfo40D',
             Condition => '$$self{Model} =~ /EOS 40D$/',
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::CameraInfo40D',
-            },
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo40D' },
         },
         {
             Name => 'CanonCameraInfo50D',
             Condition => '$$self{Model} =~ /EOS 50D$/',
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::CameraInfo50D',
-            },
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo50D' },
         },
         {
             Name => 'CanonCameraInfo60D',
             Condition => '$$self{Model} =~ /EOS 60D$/',
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::CameraInfo60D',
-            },
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo60D' },
+        },
+        {
+            Name => 'CanonCameraInfo70D',
+            Condition => '$$self{Model} =~ /EOS 70D$/',
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo70D' },
+        },
+        {
+            Name => 'CanonCameraInfo80D',
+            Condition => '$$self{Model} =~ /EOS 80D$/',
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo80D' },
         },
         {
             Name => 'CanonCameraInfo450D',
             Condition => '$$self{Model} =~ /\b(450D|REBEL XSi|Kiss X2)\b/',
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::CameraInfo450D',
-            },
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo450D' },
         },
         {
             Name => 'CanonCameraInfo500D',
             Condition => '$$self{Model} =~ /\b(500D|REBEL T1i|Kiss X3)\b/',
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::CameraInfo500D',
-            },
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo500D' },
         },
         {
             Name => 'CanonCameraInfo550D',
             Condition => '$$self{Model} =~ /\b(550D|REBEL T2i|Kiss X4)\b/',
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::CameraInfo550D',
-            },
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo550D' },
+        },
+        {
+            Name => 'CanonCameraInfo600D',
+            Condition => '$$self{Model} =~ /\b(600D|REBEL T3i|Kiss X5)\b/',
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo600D' },
+        },
+        {
+            Name => 'CanonCameraInfo650D',
+            Condition => '$$self{Model} =~ /\b(650D|REBEL T4i|Kiss X6i)\b/',
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo650D' },
+        },
+        {
+            Name => 'CanonCameraInfo700D',
+            Condition => '$$self{Model} =~ /\b(700D|REBEL T5i|Kiss X7i)\b/',
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo650D' },
+        },
+        {
+            Name => 'CanonCameraInfo750D',
+            Condition => '$$self{Model} =~ /\b(750D|Rebel T6i|Kiss X8i)\b/',
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo750D' },
+        },
+        {
+            Name => 'CanonCameraInfo760D',
+            Condition => '$$self{Model} =~ /\b(760D|Rebel T6s|8000D)\b/',
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo750D' },
         },
         {
             Name => 'CanonCameraInfo1000D',
             Condition => '$$self{Model} =~ /\b(1000D|REBEL XS|Kiss F)\b/',
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::CameraInfo1000D',
-            },
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo1000D' },
+        },
+        {
+            Name => 'CanonCameraInfo1100D',
+            Condition => '$$self{Model} =~ /\b(1100D|REBEL T3|Kiss X50)\b/',
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo600D' },
+        },
+        {
+            Name => 'CanonCameraInfo1200D',
+            Condition => '$$self{Model} =~ /\b(1200D|REBEL T5|Kiss X70)\b/',
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfo60D' },
         },
         {
@@ -894,7 +1348,5 @@
             # valid if format is int32u[138] or int32u[148]
             Condition => '$format eq "int32u" and ($count == 138 or $count == 148)',
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::CameraInfoPowerShot',
-            },
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfoPowerShot' },
         },
         {
@@ -905,7 +1357,5 @@
                 $count == 167 or $count == 171 or $count == 264)
             },
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::CameraInfoPowerShot2',
-            },
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfoPowerShot2' },
         },
         {
